<style lang="scss">
  .fileDropzone {
    position: relative;
    &__zone {
      display: inline-block;
      cursor: pointer;
      padding: .25em;
      border: 1px dashed #b5b5b5;
      border-radius: 6px;
    }
    &__input {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      opacity: 0;
      outline: none;
      z-index: -1;
    }
  }
</style>

<template>
  <label class="control fileDropzone">
    <div
      class="fileDropzone__zone is-primary"
      @drop.prevent="onFile"
    >
      <section class="section">
        <div class="content has-text-centered">
          <p>
            <span class="icon">
              <i class="material-icons">cloud_upload</i>
            </span>
          </p>
          <p>Drop your files here or click to upload</p>
        </div>
      </section>
    </div>
    <input
      type="file"
      v-bind="$attrs"
      @change="onFile"
      :value="file"
      class="fileDropzone__input"
    >
  </label>
</template>

<script lang="ts">
  import Vue from 'vue';
  import Component from 'vue-class-component';

  @Component({})
  export default class FileDropzone extends Vue {
    file = null;
    loading: boolean = false;
    onFile(event) {
      event.preventDefault();
      const files = event.target.files || event.dataTransfer.files;
      const file = files[0];
      this.$emit('change', file);
      this.file = null;
    }
  }
</script>
